/*
 * Borland's Graphics Interface Simulater on Xlib / Header File < graphiks.h >
 *
 * w]vhcnvp afhV~[^ g֐Q  wafh  Version 2 
 *
 * Copyleft (c) 1993 Tokyo Denki University, Kotani Lab., Taiji Yamada
 */
#ifndef _GRAPHIKS_H_
#define _GRAPHIKS_H_

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "graphics.h"

typedef struct _bgi {
  int                     Driver, Mode;
  int                     Error;
  int                     ActivePage, VisualPage;
  int                     FGColor, BGColor;
  struct palettetype      Palette;
  struct linesettingstype LineSetting;
  struct textsettingstype TextSetting;
  struct fillsettingstype FillSetting;
  struct pointtype        MaxPoint, CurrentPoint;
  struct viewporttype     ViewPort;
  unsigned char           RGB[MAXCOLORS+1][3];
} bgi;

typedef struct _xbgi {
  bgi           BGI;
  Display      *Disp;
  int           Screen, Depth;
  Window        Root;
  Window        Win[XBGIMaxPage];
  GC            GC;
  GC            GCPutPixel;
  GC            GCPutImage;
  GC            GCFill;
  XFontStruct  *FontInfo;
  Colormap      ColorMap;
  unsigned char ColorTable[256];
  unsigned long Pixels[MAXCOLORS+1];
} xbgi;

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern xbgi *creategraph(
#if NeedFunctionPrototypes
  int *__graphdriver, int *__graphmode, char *__pathtodriver
#endif
);

extern void destroygraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

extern void currentgraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _GRAPHIKS_H_ */
