/*
 * 3D Axes Rotation Graphic Library for Borland's Graphic Interface / Include File < graphr3_.h >
 *
 * R_ϊp OtBbN C^[tF[X for afh
 *
 * Copyleft (c) 1993 Tokyo Denki University, Kotani Lab., Taiji Yamada
 */
#if !defined(_GRAPHR3__H_)
#define _GRAPHR3__H_
#include <graphix_.h>

double _RCA = 1.0/1.41421356, _RSA = -1.0/1.41421356;
double _RCB = 1.7320508,      _RSB =  1.0/2;
double _RCC = 1.0/1.41421356, _RSC = -1.0/1.41421356;
double _R0X = 0.0, _R0Y = 0.0, _R0Z = 0.0;
double _RFX = 1.0, _RFY = 1.0, _RFZ = 1.0;
/*
 * JgړʃZbg
 */
void setmovement_( double x, double y, double z )
{
  _R0X = x; _R0Y = y; _R0Z = z;
}
/*
 * Jgg嗦Zbg
 */
void setscaling_( double dx, double dy, double dz )
{
  _RFX = dx; _RFY = dy; _RFZ = dz;
}
/*
 * Jg]pxZbg: px, px, px
 */
void setrotation_( double a, double b, double c )
{
  _RCA = cos(a); _RSA = sin(a);
  _RCB = cos(b); _RSB = sin(b);
  _RCC = cos(c); _RSC = sin(c);
}
void setrotationx_( double a )
{
  _RCA = cos(a); _RSA = sin(a);
}
void setrotationy_( double b )
{
  _RCB = cos(b); _RSB = sin(b);
}
void setrotationz_( double c )
{
  _RCC = cos(c); _RSC = sin(c);
}
/*
 * ->ʓeϊ}N
 */
#define r3tox(x,y,z) ((_RFX*(x+_R0X)*_RCB+_RFZ*(z+_R0Z)*_RSB)*_RCC \
                     -(_RFY*(y+_R0Y)*_RCA-(-_RFX*(x+_R0X)*_RSB+_RFZ*(z+_R0Z)*_RCB)*_RSA)*_RSC)
#define r3toy(x,y,z) ((_RFX*(x+_R0X)*_RCB+_RFZ*(z+_R0Z)*_RSB)*_RSC \
                     +(_RFY*(y+_R0Y)*_RCA-(-_RFX*(x+_R0X)*_RSB+_RFZ*(z+_R0Z)*_RCB)*_RSA)*_RCC)
#define r3toz(x,y,z)  (_RFY*(y+_R0Y)*_RSA+(-_RFX*(x+_R0X)*_RSB+_RFZ*(z+_R0Z)*_RCB)*_RCA)
/*
 * h[n֐}N
 */
#define liner3_(x1,y1,z1,x2,y2,z2) \
                             line_(r3tox(x1,y1,z1),r3toy(x1,y1,z1),r3tox(x2,y2,z2),r3toy(x2,y2,z2))
#define linetor3_(x,y,z)     lineto_(r3tox(x,y,z),r3toy(x,y,z))
#define putpixelr3_(x,y,z,c) putpixel_(r3tox(x,y,z),r3toy(x,y,z),c)
#define movetor3_(x,y,z)     moveto_(r3tox(x,y,z),r3toy(x,y,z))
void cuber3_( double xf, double yf, double zf, double xt, double yt, double zt, int flg )
{
  int i, mini;
  double x0, y0, z0, x1, y1, z1, minz, z;
  static int l[12][2] = {
    { 0, 1 }, { 0, 2 }, { 0, 4 },
    { 1, 3 }, { 1, 5 },
    { 2, 3 },
    { 5, 4 },
    { 6, 4 }, { 6, 2 },
    { 7, 6 }, { 7, 5 }, { 7, 3 }, 
  };

  minz = r3toz( xf, yf, zf );
  mini = 0;
  for ( i=1; i<12; i++ ){
    x0 = ((i/1%2==0)?xf:xt);
    y0 = ((i/2%2==0)?yf:yt);
    z0 = ((i/4%2==0)?zf:zt);
    z = r3toz( x0, y0, z0 );
    if ( z<minz ){
      minz = z;
      mini = i;
    }
  }
  for ( i=0; i<12; i++ ){
    x0 = ((l[i][0]/1%2==0)?xf:xt); x1 = ((l[i][1]/1%2==0)?xf:xt);
    y0 = ((l[i][0]/2%2==0)?yf:yt); y1 = ((l[i][1]/2%2==0)?yf:yt);
    z0 = ((l[i][0]/4%2==0)?zf:zt); z1 = ((l[i][1]/4%2==0)?zf:zt);
    if ((flg)&&( l[i][0]==mini )||( l[i][1]==mini ))
      setlinestyle( DOTTED_LINE, 0, NORM_WIDTH );
    else
      setlinestyle( SOLID_LINE, 0, NORM_WIDTH );
    liner3_( x0, y0, z0, x1, y1, z1 );
  }
}

#endif
