/*
 * Borland's Graphics Interface Simulater on Xlib / Source File < graphics.c >
 *
 * w]vhcnvp afhV~[^  wafh  Version 2
 *
 * Copyleft (c) 1993 Tokyo Denki University, Kotani Lab., Taiji Yamada
 */
#include <malloc.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include "graphics.h"
#include "graphiks.h"

#define FALSE    0
#define TRUE     !FALSE
#define max(a,b) (((a)>(b))?(a):(b))
#define min(a,b) (((a)<(b))?(a):(b))
#define minmax(a,x,b) ((((a)<=(x))&&((x)<=(b)))?(x):(((x)<(a))?(a):(b)))
#define Xx(x)    (XBGI->BGI.ViewPort.left+(x))
#define Xy(y)    (XBGI->BGI.ViewPort.top +(y))

/*                                                    */
/* the Current XBGI to Draw to and the Number of XBGI */
/*                                                    */
xbgi *XBGI;
int nXBGI = -1;

static int XBGIOpTable[] = {
  GXcopy, GXxor, GXor, GXand, GXcopyInverted,
};
static char *XBGIFontName[XBGIMaxFont][XBGIMaxFontSize]={
#include "udef.chr"
#include "trip.chr"
#include "litt.chr"
#include "sans.chr"
#include "goth.chr"
};
static int arc_x, arc_y, arc_xrad, arc_yrad, arc_sang, arc_eang;
static void rferror( char* err )
{
  static int flg = !0;

  if ( flg )
    fprintf( stderr, "XBGI Warning -> Reserved Future. <%s>\n", err );
  flg = 0;
}
static void nserror( char* err )
{
  static int flg = !0;

  if ( flg )
    fprintf( stderr, "XBGI Warning -> Not Supported. <%s>\n", err );
  flg = 0;
}
static void polypoints2xpoints( int n, int polypoints[], XPoint *xpoints )
{
  int i;

  for ( i=0; i<n; i++ ){
    xpoints->x = Xx( *polypoints++ );
    xpoints->y = Xy( *polypoints++ );
    xpoints++;
  }
}
void xbgiutil( void )
{
}
void xbgiloop( void )
{
  XEvent ev;
  char c;
  
  XFlush( XBGI->Disp );
  while (1){
    XNextEvent( XBGI->Disp, &ev );
    switch ( ev.type ){
    case KeyPress:
      if ( 1==XLookupString( (XKeyEvent*)&ev, &c, 1, NULL, NULL ) ){
        switch( c ){
        case 'q': /* L[{[h 'q', 'Q' or 'ctrl+c' Ń[vI */
        case 'Q':
        case '\03':
          return;
	  break;
        case 'b': /* L[{[h 'b' or 'B' ŃrWAy[WobN */
        case 'B':
	  if ( 0 < XBGI->BGI.VisualPage )
	    setvisualpage( XBGI->BGI.VisualPage-1 );
    	  break;
        case 'n': /* L[{[h 'n' or 'N' ŃrWAy[WlNXg */
        case 'N':
	  if ( XBGI->BGI.VisualPage < XBGIMaxPage )
	    setvisualpage( XBGI->BGI.VisualPage+1 );
    	  break;
	}
	break;
      }
      break;
    case ButtonPress:
      switch( (ev.xbutton).button ){
      case Button3: /* }EX{^RŃ[vI */
	return;
	break;
      case Button1: /* }EX{^QŃrWAy[WobN */
	if ( 0 < XBGI->BGI.VisualPage )
	  setvisualpage( XBGI->BGI.VisualPage-1 );
	break;
      case Button2: /* }EX{^PŃrWAy[WlNXg */
	if ( XBGI->BGI.VisualPage < XBGIMaxPage )
	  setvisualpage( XBGI->BGI.VisualPage+1 );
	break;
      }
      break;
    case ConfigureNotify:
      /* 
       * EBhẼTCY getmaxx()  getmaxy() ̕ԂlύXB
       * afhEBhEg̓TCYȂ̂ŁAvO}
       * ȉ̂悤ȃeNjbNłafhEBhETCY邱ƁB
       *
       * xbgiloop();
       * setmaxx( getmaxx() );
       * setmaxy( getmaxy() ); 
       *
       */
      XBGI->BGI.MaxPoint.x = ev.xconfigure.width - 1;
      XBGI->BGI.MaxPoint.y = ev.xconfigure.height - 1;
      break;
    }
  }
}
void xflush( void )
{
  XFlush( XBGI->Disp );
}
void settitle( char *title )
{
  XStoreName( XBGI->Disp, XBGI->Root, title );
  XSetIconName( XBGI->Disp, XBGI->Root, title );
}
void setmaxx( int x )
{
  int i;
  
  XBGI->BGI.MaxPoint.x = x;
  XResizeWindow( XBGI->Disp, XBGI->Root, XBGI->BGI.MaxPoint.x+1, XBGI->BGI.MaxPoint.y+1 );
  for ( i=0; i<XBGIMaxPage; i++ ){
    XResizeWindow( XBGI->Disp, XBGI->Win[i], XBGI->BGI.MaxPoint.x+1, XBGI->BGI.MaxPoint.y+1 );
  }
}
void setmaxy( int y )
{
  int i;
  
  XBGI->BGI.MaxPoint.y = y;
  XResizeWindow( XBGI->Disp, XBGI->Root, XBGI->BGI.MaxPoint.x+1, XBGI->BGI.MaxPoint.y+1 );
  for ( i=0; i<XBGIMaxPage; i++ ){
    XResizeWindow( XBGI->Disp, XBGI->Win[i], XBGI->BGI.MaxPoint.x+1, XBGI->BGI.MaxPoint.y+1 );
  }
}
void setbackingstore( int flg )
{
  int i;
  XSetWindowAttributes att;

  if ( flg )
    att.backing_store = Always;
  else
    att.backing_store = NotUseful;
  XChangeWindowAttributes( XBGI->Disp, XBGI->Root, CWBackingStore, &att );
  for ( i=0; i<XBGIMaxPage; i++ ){
    XChangeWindowAttributes( XBGI->Disp, XBGI->Win[i], CWBackingStore, &att );
  }
}
/* the following functions are standard on BGI */
void arc( int x, int y, int stangle, int endangle, int radius )
{
  arc_x    = x;
  arc_y    = y;
  arc_xrad = radius;
  arc_yrad = radius;
  arc_sang = stangle;
  arc_eang = endangle;
  XDrawArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
           Xx( x - radius ), Xy( y - radius ), 2 * radius, 2 * radius,
           64 * stangle, 64 * ( endangle - stangle ) );
}
void bar( int left, int top, int right, int bottom )
{
  XFillRectangle( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCFill,
                 min(Xx(left),Xx(right)), min(Xy(top),Xy(bottom)),
		 abs(right-left)+1, abs(bottom-top)+1 );
/*  XDrawRectangle( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
                 min(Xx(left),Xx(right)), min(Xy(top),Xy(bottom)),
		 abs(right-left), abs(bottom-top) );*/
}
void bar3d( int left, int top, int right, int bottom, int depth, int topflag )
{
  int topheight = 0;
  XPoint xpoints[4];

  if ( topflag == TRUE ) topheight = depth/2;
  xpoints[0].x = Xx( right );         xpoints[0].y = Xy( top );
  xpoints[1].x = Xx( right + depth ); xpoints[1].y = Xy( top - topheight );
  xpoints[2].x = Xx( left + depth );  xpoints[2].y = Xy( top - topheight );
  xpoints[3].x = Xx( left );          xpoints[3].y = Xy( top );
  XDrawLines( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC, xpoints, 4, CoordModeOrigin );
  xpoints[0].x = Xx( right );         xpoints[0].y = Xy( top );
  xpoints[1].x = Xx( right );         xpoints[1].y = Xy( bottom );
  xpoints[2].x = Xx( right + depth ); xpoints[2].y = Xy( bottom - topheight );
  xpoints[3].x = Xx( right + depth ); xpoints[3].y = Xy( top - topheight );
  XDrawLines( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC, xpoints, 4, CoordModeOrigin );
  XFillRectangle( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCFill,
                 min(Xx(left),Xx(right)), min(Xy(top),Xy(bottom)),
		 abs(right-left)+1, abs(bottom-top)+1 );
  XDrawRectangle( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
                 min(Xx(left),Xx(right)), min(Xy(top),Xy(bottom)),
		 abs(right-left), abs(bottom-top) );
}
void circle( int x, int y, int radius )
{
  arc_x    = x;
  arc_y    = y;
  arc_xrad = radius;
  arc_yrad = radius;
  arc_sang = 0;
  arc_eang = 360;
  XDrawArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
           Xx( x - radius ), Xy( y - radius ), 2 * radius, 2 * radius, 0, 64 * ( 360 - 0 ) );
}
void cleardevice( void )
{
  XClearWindow( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage] );
}
void clearviewport( void )
{
  if ( XBGI->BGI.ViewPort.clip == FALSE ){
    cleardevice();
    return;
  }else{
    XClearArea( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage],
               XBGI->BGI.ViewPort.left, XBGI->BGI.ViewPort.top, 
               XBGI->BGI.ViewPort.right - XBGI->BGI.ViewPort.left+1,
               XBGI->BGI.ViewPort.bottom - XBGI->BGI.ViewPort.top+1, False );
  }
}
void closegraph( void )
{
  destroygraph( XBGI );
}
void detectgraph( int *graphdriver,int *graphmode )
{
  /* get it from visual class of X */
  *graphdriver = DETECT;
  *graphmode = BGIC16;
}
void drawpoly( int numpoints, int *polypoints )
{
  XPoint *xpoints = (XPoint *)malloc( numpoints * sizeof(XPoint) );

  polypoints2xpoints( numpoints, polypoints, xpoints );
  XDrawLines( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
	     xpoints, numpoints, CoordModeOrigin );
  free( xpoints );
}
void ellipse( int x, int y, int stangle, int endangle, int xradius, int yradius )
{
  arc_x    = x;
  arc_y    = y;
  arc_xrad = xradius;
  arc_yrad = yradius;
  arc_sang = stangle;
  arc_eang = endangle;
  XDrawArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
           Xx( x - xradius ), Xy( y - yradius ), 2 * xradius, 2 * yradius,
           64 * stangle, 64 * ( endangle - stangle ) );
}
void fillellipse( int x, int y, int xradius, int yradius )
{
  arc_x    = x;
  arc_y    = y;
  arc_xrad = xradius;
  arc_yrad = yradius;
  arc_sang = 0;
  arc_eang = 360;
  XFillArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCFill,
           Xx( x - xradius ), Xy( y - yradius) , 2 * xradius, 2 * yradius, 0, 64 * ( 360 - 0 ) );
  XDrawArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
           Xx( x - xradius ), Xy( y - yradius) , 2 * xradius, 2 * yradius, 0, 64 * ( 360 - 0 ) );
}
void fillpoly( int numpoints, int *polypoints )
{
  XPoint *xpoints = (XPoint *)malloc( numpoints * sizeof(XPoint) );

  polypoints2xpoints( numpoints, polypoints, xpoints );
  XFillPolygon( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCFill,
               xpoints, numpoints, Complex, CoordModeOrigin );
  XDrawLines( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
	     xpoints, numpoints, CoordModeOrigin );
  free( xpoints );
}
void floodfill( int x, int y, int border )
{
  rferror( "floodfill()" );
}
void getarccoords( struct arccoordstype *arccoords )
{
  arccoords->x      = arc_x;
  arccoords->y      = arc_y;
  arccoords->xstart = arc_x + (int)((double)arc_xrad*cos((double)arc_sang*M_PI/180));
  arccoords->ystart = arc_y - (int)((double)arc_yrad*sin((double)arc_sang*M_PI/180));
  arccoords->xend   = arc_x + (int)((double)arc_xrad*cos((double)arc_eang*M_PI/180));
  arccoords->yend   = arc_y - (int)((double)arc_yrad*sin((double)arc_eang*M_PI/180));
}
void getaspectratio( int *xasp, int *yasp )
{
  *xasp = 10000; *yasp = 10000;
}
int getbkcolor( void )
{
  return( XBGI->BGI.BGColor );
}
int getcolor( void )
{
  return( XBGI->BGI.FGColor );
}
struct palettetype* getdefaultpalette( void )
{
  return( &XBGI->BGI.Palette );
}
char* getdrivername( void )
{
  static char drivername[] = "XBGI DRIVER";
  return( drivername );
}
void getfillpattern( char *pattern )
{
  rferror( "getfillpattern()" );
}
void getfillsettings( struct fillsettingstype *fillinfo )
{
  *fillinfo = XBGI->BGI.FillSetting;
}
int getgraphmode( void )
{
  return( XBGI->BGI.Mode );
}
void getimage( int left, int top, int right, int bottom, void *bitmap )
{
  XImage *image;
  int width, height, i, j, k;
  unsigned char *data, *buffer = (unsigned char *)bitmap;

  width  = abs(right-left)+1;
  height = abs(bottom-top)+1;
  image = XGetImage( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage],
		    min(Xx(left),Xx(right)), min(Xy(top),Xy(bottom)),
		    width, height, AllPlanes, ZPixmap );
  data = (unsigned char *)image->data;
  *buffer++ = width;
  *buffer++ = height;
  for ( i=0; i<height; i++ ){
    for ( k=j=0; j<image->bytes_per_line; j++, data++ ){
      if ( j<image->xoffset ) continue;
      k++;
      if ( width < k ) continue;
      *buffer++ = XBGI->ColorTable[*data];
    }
  }
}
void getlinesettings( struct linesettingstype *lineinfo )
{
  *lineinfo = XBGI->BGI.LineSetting;
}
int getmaxcolor( void )
{
  return( XBGI->BGI.Palette.size-1 );
}
int getmaxmode( void )
{
  return( BGIC256 );
}
int getmaxx( void )
{
  return( XBGI->BGI.MaxPoint.x );
}
int getmaxy( void )
{
  return( XBGI->BGI.MaxPoint.y );
}
char* getmodename( int mode_number )
{
  static char modename[50];
  sprintf( modename, "%d COLOR MODE", XBGI->BGI.Mode );
  return( modename );
}
void getmoderange( int graphdriver, int *lomode, int *himode )
{
  nserror( "getmoderange()" );
}
unsigned getpixel( int x, int y )
{
  XImage *image;
  int val;

  image = XGetImage( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage],
		    Xx( x ), Xy( y ), 1, 1, AllPlanes, ZPixmap );
  val = XBGI->ColorTable[image->data[image->xoffset]];
  XDestroyImage( image );
  return( ( unsigned )val );
}
void getpalette( struct palettetype *palette )
{
  *palette = XBGI->BGI.Palette;
}
int getpalettesize( void )
{
  return( XBGI->BGI.Palette.size );
}
void gettextsettings( struct textsettingstype *texttypeinfo )
{
  *texttypeinfo = XBGI->BGI.TextSetting;
}
void getviewsettings( struct viewporttype *viewport )
{
  *viewport = XBGI->BGI.ViewPort;
}
int getx( void )
{
  return( XBGI->BGI.CurrentPoint.x );
}
int gety( void )
{
  return( XBGI->BGI.CurrentPoint.y );
}
void graphdefaults( void )
{
  int c, cc;
  char title[50];
  int rgb[8][3] = {
    {0, 0, 0},
    {0, 0, 1},
    {0, 1, 0},
    {0, 1, 1},
    {1, 0, 0},
    {1, 0, 1},
    {1, 1, 0},
    {1, 1, 1},
  };
  
  setactivepage( 0 );
  setvisualpage( 0 );
  setcolor( WHITE );
  setbkcolor( BLACK );
  setlinestyle( SOLID_LINE, 0, NORM_WIDTH );
  settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
  settextjustify( LEFT_TEXT, TOP_TEXT );
  setfillstyle( SOLID_FILL, WHITE );
  moveto( 0, 0 );
  setviewport( 0, 0, XBGI->BGI.MaxPoint.x, XBGI->BGI.MaxPoint.y, TRUE ); 
  for ( c=0; c<XBGI->BGI.Palette.size; c++ )
    setpalette( c, c ); 
  for ( c=0; c<XBGI->BGI.Palette.size/8; c++ )
    for ( cc=0; cc<8; cc++ )
      setrgbpalette( 8*c+cc, 8*(c+1)*rgb[cc][0], 8*(c+1)*rgb[cc][1], 8*(c+1)*rgb[cc][2] );
  for ( c=1; c<XBGI->BGI.Palette.size/8; c++ )
    setrgbpalette( 8*c+0, 4*(c+1), 4*(c+1), 4*(c+1) );
  cc = XBGI->BGI.Palette.size/2;
  for ( c=0; c<XBGI->BGI.Palette.size/8; c++ )
    setrgbpalette( 8*c+7, cc+4*(c+1), cc+4*(c+1), cc+4*(c+1) );
  sprintf( title, "XBGI Graph %d", nXBGI+1 );
  settitle( title );
}
char* grapherrormsg( int errorcode )
{
  rferror( "grapherrormsg()" );
  return( NULL );
}
void _graphfreemem( void *ptr, unsigned size )
{
  nserror( "_graphfreemem()" );
}
void* _graphgetmem( unsigned size )
{
  nserror( "_graphgetmem()" );
  return( NULL );
}
int graphresult( void )
{
  return( XBGI->BGI.Error );
}
unsigned imagesize( int left, int top, int right, int bottom )
{
  return( (unsigned)(2 + (abs(right-left)+1)*(abs(bottom-top)+1)) );
}
void initgraph( int *graphdriver, int *graphmode, char *pathtodriver )
{
  XBGI = creategraph( graphdriver, graphmode, pathtodriver );
  settitle( "XBGI" );
}
int installuserdriver( char *name, int (*detect)( void ) )
{
  rferror( "installuserdriver()" );
  return( 0 );
}
int installuserfont( char *name )
{
  rferror( "installuserfont()" );
  return( 0 );
}
void line( int x1, int y1, int x2, int y2 )
{
  XDrawLine( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
            Xx( x1 ), Xy( y1 ), Xx( x2 ), Xy( y2 ) );
}
void linerel( int dx, int dy )
{
  XDrawLine( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
            Xx( XBGI->BGI.CurrentPoint.x ), Xy( XBGI->BGI.CurrentPoint.y ),
            Xx( XBGI->BGI.CurrentPoint.x + dx ), Xy( XBGI->BGI.CurrentPoint.y + dy ) );
  XBGI->BGI.CurrentPoint.x += dx;
  XBGI->BGI.CurrentPoint.y += dy;
}
void lineto( int x, int y )
{
  XDrawLine( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
            Xx( XBGI->BGI.CurrentPoint.x ), Xy( XBGI->BGI.CurrentPoint.y ), Xx( x ), Xy( y ) );
  XBGI->BGI.CurrentPoint.x = x;
  XBGI->BGI.CurrentPoint.y = y;
}
void moverel( int dx, int dy )
{
  XBGI->BGI.CurrentPoint.x += dx;
  XBGI->BGI.CurrentPoint.y += dy;
}
void moveto( int x, int y )
{
  XBGI->BGI.CurrentPoint.x = x;
  XBGI->BGI.CurrentPoint.y = y;
}
void outtext( char *textstring )
{
  outtextxy( XBGI->BGI.CurrentPoint.x, XBGI->BGI.CurrentPoint.y, textstring );
  moverel( textwidth(textstring), 0 );
}
void outtextxy( int x, int y, char *textstring )
{
  int txt_x, txt_y;
  register p_x, p_y;
  Pixmap p1, p2;
  XImage *image;
  int val;

  switch ( XBGI->BGI.TextSetting.direction ){
  case VERT_DIR:
    p1 = XCreatePixmap( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage],
		       textwidth(textstring), textheight(textstring),XBGI->Depth );
    p2 = XCreatePixmap( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage],
		       textheight(textstring), textwidth(textstring),XBGI->Depth );
    switch( XBGI->BGI.TextSetting.horiz ){
    case LEFT_TEXT:
      txt_x = x;
      break;
    case CENTER_TEXT:
      txt_x = x - textheight(textstring)/2;
      break;
    case RIGHT_TEXT:
      txt_x = x - textheight(textstring);
      break;
    }
    switch( XBGI->BGI.TextSetting.vert ){
    case TOP_TEXT:
      txt_y = y;
      break;
    case CENTER_TEXT:
      txt_y = y - textwidth(textstring)/2;
      break;
    case BOTTOM_TEXT:
      txt_y = y - textwidth(textstring);
      break;
    }
    XSetForeground( XBGI->Disp, XBGI->GC, XBGI->Pixels[XBGI->BGI.BGColor] );
    XFillRectangle( XBGI->Disp, p1, XBGI->GC,0,0,
		   textwidth(textstring),textheight(textstring) );
    XSetForeground( XBGI->Disp, XBGI->GC, XBGI->Pixels[XBGI->BGI.FGColor] );
    XDrawString( XBGI->Disp, p1, XBGI->GC, 0, textheight(textstring)-1,
		textstring, strlen(textstring) );
    XCopyArea( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], p2, XBGI->GC, txt_x, txt_y,
	      textheight(textstring), textwidth(textstring),0,0 );
    for (p_y=0; p_y<textheight(textstring); p_y++){
      for (p_x=0; p_x<textwidth(textstring); p_x++){
	image = XGetImage( XBGI->Disp, p1, p_x, p_y, 1, 1, AllPlanes, ZPixmap );
	val = XBGI->ColorTable[image->data[image->xoffset]];
	if (val==XBGI->BGI.FGColor)
	  XDrawPoint( XBGI->Disp, p2, XBGI->GC, p_y, textwidth(textstring)-p_x-1 );
	XDestroyImage( image );
      }
    }
    XCopyArea( XBGI->Disp, p2, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC, 0, 0,
	      textheight(textstring), textwidth(textstring),txt_x,txt_y );
    XSetForeground( XBGI->Disp, XBGI->GC, XBGI->Pixels[XBGI->BGI.FGColor] );
    XFreePixmap( XBGI->Disp, p1 );
    XFreePixmap( XBGI->Disp, p2 );
    break;
  case HORIZ_DIR:
    switch( XBGI->BGI.TextSetting.horiz ){
    case LEFT_TEXT:
      txt_x = x;
      break;
    case CENTER_TEXT:
      txt_x = x - textwidth(textstring)/2;
      break;
    case RIGHT_TEXT:
      txt_x = x - textwidth(textstring);
      break;
    }
    switch( XBGI->BGI.TextSetting.vert ){
    case TOP_TEXT:
      txt_y = y + textheight(textstring);
      break;
    case CENTER_TEXT:
      txt_y = y + textheight(textstring)/2;
      break;
    case BOTTOM_TEXT:
      txt_y = y;
      break;
    }
    XDrawString( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
		Xx( txt_x ), Xy( txt_y ), textstring, strlen(textstring) );
    break;
  }
}
void pieslice( int x, int y, int stangle, int endangle, int radius )
{
  static struct arccoordstype arccoords;

  arc_x    = x;
  arc_y    = y;
  arc_xrad = radius;
  arc_yrad = radius;
  arc_sang = stangle;
  arc_eang = endangle;
  getarccoords( &arccoords );
  XFillArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCFill,
           Xx( x - radius ), Xy( y - radius ), 2 * radius, 2 * radius,
           64 * stangle, 64 * ( endangle - stangle ) );
  XDrawArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
           Xx( x - radius ), Xy( y - radius ), 2 * radius, 2 * radius,
           64 * stangle, 64 * ( endangle - stangle ) );
  line( arccoords.xstart, arccoords.ystart, arccoords.x, arccoords.y );
  line( arccoords.xend,   arccoords.yend,   arccoords.x, arccoords.y );
}
void putimage( int left, int top, void *bitmap, int op )
{
  static int StaticOp = COPY_PUT;
  int width, height;
  XImage *image;
  unsigned char *b, *buffer = (unsigned char *)bitmap;
  int i;

  width  = *buffer++;
  height = *buffer++;
  b = buffer;
  for ( i=0; i<width*height; i++ )
    *b++ = XBGI->Pixels[*b];
  if ( op != StaticOp ){
    StaticOp = op;
    XSetFunction( XBGI->Disp, XBGI->GCPutImage, XBGIOpTable[StaticOp] );
  }
  image = XCreateImage( XBGI->Disp, DefaultVisual(XBGI->Disp,XBGI->Screen), XBGI->Depth,
                       ZPixmap, 0, (char *)buffer, width, height, 8, 0 );
  XPutImage( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCPutImage, image,
            0, 0, Xx(left), Xy(top), width, height );
  XDestroyImage( image );
}
void putpixel( int x, int y, int color )
{
  static int c = WHITE;

  if ( c != color ){
    c = color;
    XSetForeground( XBGI->Disp, XBGI->GCPutPixel, XBGI->Pixels[color] );
  }
  XDrawPoint( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCPutPixel, Xx(x), Xy(y) );
}
void rectangle( int left, int top, int right, int bottom )
{
  XDrawRectangle( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
                 min(Xx(left),Xx(right)), min(Xy(top),Xy(bottom)),
		 abs(right-left), abs(bottom-top) );
}
void restorecrtmode( void )
{
  nserror( "restorecrtmode()" );
}
void sector( int x, int y, int stangle, int endangle, int xradius, int yradius )
{
  arc_x    = x;
  arc_y    = y;
  arc_xrad = xradius;
  arc_yrad = yradius;
  arc_sang = stangle;
  arc_eang = endangle;
  XFillArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GCFill,
           Xx( x - xradius ), Xy( y - yradius ), 2 * xradius, 2 * yradius,
           64 * stangle, 64 * ( endangle - stangle ) );
  XDrawArc( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], XBGI->GC,
	   Xx( x - xradius ), Xy( y - yradius ), 2 * xradius, 2 * yradius,
	   64 * stangle, 64 * ( endangle - stangle ) );
}
void setactivepage( int page )
{
  if (( 0 <= page )&&( page < XBGIMaxPage ))
    XBGI->BGI.ActivePage = page;
}
void setallpalette( struct palettetype *palette )
{
  int c;

  XBGI->BGI.Palette = *palette;
  for ( c=0; c<palette->size; c++ )
    setpalette( palette->colors[c], c ); 
}
void setaspectratio( int xasp, int yasp )
{
  rferror( "setaspectratio()" );
}
void setbkcolor( int color )
{
  XBGI->BGI.BGColor = color;
  XSetWindowBackground( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage], 
		       XBGI->Pixels[XBGI->BGI.BGColor] );
  /*XClearWindow( XBGI->Disp, XBGI->Win[XBGI->BGI.ActivePage] );*/
}
void setcolor( int color )
{
  XBGI->BGI.FGColor = color;
  XSetForeground( XBGI->Disp, XBGI->GC, XBGI->Pixels[XBGI->BGI.FGColor] );
}
#include "user_fill.xbm"
void setfillpattern( char *upattern, int color )
{
  int i;
  Pixmap pm_fill;

  XBGI->BGI.FillSetting.pattern = USER_FILL;
  XBGI->BGI.FillSetting.color   = color;
  for ( i=0; i<8; i++ )
    user_fill_bits[i] = upattern[i];
  XSetForeground( XBGI->Disp, XBGI->GCFill, XBGI->Pixels[XBGI->BGI.FillSetting.color] );
  pm_fill = XCreateBitmapFromData( XBGI->Disp, XBGI->Root, user_fill_bits, 8, 8 );
  XSetStipple( XBGI->Disp, XBGI->GCFill, pm_fill );
  XSetFillStyle( XBGI->Disp, XBGI->GCFill, FillStippled );
}
void setfillstyle( int pattern, int color )
{
#include "line_fill.xbm"
#include "ltslash_fill.xbm"
#include "slash_fill.xbm"
#include "bkslash_fill.xbm"
#include "ltbkslash_fill.xbm"
#include "hatch_fill.xbm"
#include "xhatch_fill.xbm"
#include "interleave_fill.xbm"
#include "wide_dot_fill.xbm"
#include "close_dot_fill.xbm"
  Pixmap pm_fill;
  static char *bits[USER_FILL+1] = {
    NULL,
    NULL,
    line_fill_bits,
    ltslash_fill_bits,
    slash_fill_bits,
    bkslash_fill_bits,
    ltbkslash_fill_bits,
    hatch_fill_bits,
    xhatch_fill_bits,
    interleave_fill_bits,
    wide_dot_fill_bits,
    close_dot_fill_bits,
    user_fill_bits,
  };

  XBGI->BGI.FillSetting.pattern = pattern;
  XBGI->BGI.FillSetting.color   = color;
  switch( pattern ){
  case EMPTY_FILL:
    XSetForeground( XBGI->Disp, XBGI->GCFill, XBGI->Pixels[XBGI->BGI.BGColor] );
    XSetFillStyle( XBGI->Disp, XBGI->GCFill, FillSolid );
    break;
  case SOLID_FILL:
    XSetForeground( XBGI->Disp, XBGI->GCFill, XBGI->Pixels[XBGI->BGI.FillSetting.color] );
    XSetFillStyle( XBGI->Disp, XBGI->GCFill, FillSolid );
    break;
  case LINE_FILL:
  case LTSLASH_FILL:
  case SLASH_FILL:
  case BKSLASH_FILL:
  case LTBKSLASH_FILL:
  case HATCH_FILL:
  case XHATCH_FILL:
  case INTERLEAVE_FILL:
  case WIDE_DOT_FILL:
  case CLOSE_DOT_FILL:
  case USER_FILL:
    XSetForeground( XBGI->Disp, XBGI->GCFill, XBGI->Pixels[color] );
    pm_fill = XCreateBitmapFromData( XBGI->Disp, XBGI->Root, bits[pattern], 8, 8 );
    XSetStipple( XBGI->Disp, XBGI->GCFill, pm_fill );
    XSetFillStyle( XBGI->Disp, XBGI->GCFill, FillStippled );
    break;
  default:
    XSetForeground( XBGI->Disp, XBGI->GCFill, XBGI->Pixels[color] );
    XSetFillStyle( XBGI->Disp, XBGI->GCFill, FillSolid );
    break;
  }
}
unsigned setgraphbufsize( unsigned bufsize )
{
  nserror( "setgraphbufsize()" );
  return( 0 );
}
void setgraphmode( int mode )
{
  int i;
  unsigned long plane_mask[1];

  XBGI->BGI.Mode = mode;
  switch( XBGI->BGI.Mode ){
  case BGIMONO:
    break;
  case BGIC2:
  case BGIC4:
  case BGIC8:
  case BGIC16:
  case BGIC32:
  case BGIC64:
  case BGIC128:
  case BGIC136:
  case BGIC144:
  case BGIC152:
  case BGIC160:
  case BGIC168:
  case BGIC176:
  case BGIC184:
  case BGIC192:
  case BGIC200:
  case BGIC256:
    XBGI->BGI.Palette.size = XBGI->BGI.Mode;
    break;
  default:
    XBGI->BGI.Mode = BGIC16;
    XBGI->BGI.Palette.size = BGIC16;
    break;
  }
  switch( XBGI->BGI.Mode ){
  case BGIMONO:
    XBGI->ColorMap = DefaultColormap( XBGI->Disp, XBGI->Screen ); 
    XBGI->ColorTable[BlackPixel(XBGI->Disp, XBGI->Screen)] = 0;
    XBGI->ColorTable[WhitePixel(XBGI->Disp, XBGI->Screen)] = 1;
    break;
  case BGIC2:
  case BGIC4:
  case BGIC8:
  case BGIC16:
  case BGIC32:
  case BGIC64:
  case BGIC128:
  case BGIC256:
    XBGI->ColorMap = DefaultColormap( XBGI->Disp, XBGI->Screen ); 
    XAllocColorCells( XBGI->Disp, XBGI->ColorMap,
		     False, plane_mask, 0, XBGI->Pixels, XBGI->BGI.Palette.size );
    for ( i=0; i<XBGI->BGI.Palette.size; i++ )
      XBGI->ColorTable[XBGI->Pixels[i]] = i;
    setallpalette( &XBGI->BGI.Palette );
    break;
  }
}
void setlinestyle( int linestyle, unsigned upattern, int thickness )
{
  static char dotted[] = { 1, 3 };
  static char center[] = { 1, 3, 4, 3 };
  static char dashed[] = { 7, 4 };

  XBGI->BGI.LineSetting.linestyle = linestyle;
  XBGI->BGI.LineSetting.upattern  = upattern;
  XBGI->BGI.LineSetting.thickness = thickness;
  switch( linestyle ){
  case SOLID_LINE:
  break;
  case DOTTED_LINE:
    XSetDashes( XBGI->Disp, XBGI->GC, 0, dotted, 2 );
  break;
  case CENTER_LINE:
    XSetDashes( XBGI->Disp, XBGI->GC, 0, center, 4 );
  break;
  case DASHED_LINE:
    XSetDashes( XBGI->Disp, XBGI->GC, 0, dashed, 2 );
  break;
  default:
    rferror( "setlinestyle( USERBIT_LINE, , )" );
  break;
  }
  XSetLineAttributes( XBGI->Disp, XBGI->GC, thickness,
		     ((linestyle==SOLID_LINE)?LineSolid:LineOnOffDash), CapButt, JoinBevel );
}
void setpalette( int colornum, int color )
{
  XColor xcolor;
  int red, green, blue;
  
  XBGI->BGI.Palette.colors[color] = (signed char)colornum;
  red   = XBGI->BGI.RGB[colornum][0];
  green = XBGI->BGI.RGB[colornum][1];
  blue  = XBGI->BGI.RGB[colornum][2];
  xcolor.pixel = XBGI->Pixels[color];
  xcolor.red   = minmax( 0, 65536*red  /XBGI->BGI.Palette.size, 65536-1 );
  xcolor.green = minmax( 0, 65536*green/XBGI->BGI.Palette.size, 65536-1 );
  xcolor.blue  = minmax( 0, 65536*blue /XBGI->BGI.Palette.size, 65536-1 );
  xcolor.flags = DoRed | DoGreen | DoBlue;
  XStoreColor( XBGI->Disp, XBGI->ColorMap, &xcolor );
  XFlush( XBGI->Disp );
}
void setrgbpalette( int colornum, int red, int green, int blue )
{
  XColor xcolor;

  XBGI->BGI.RGB[colornum][0] = red;
  XBGI->BGI.RGB[colornum][1] = green;
  XBGI->BGI.RGB[colornum][2] = blue;
  xcolor.pixel = XBGI->Pixels[colornum];
  xcolor.red   = minmax( 0, 65536*red  /XBGI->BGI.Palette.size, 65536-1 );
  xcolor.green = minmax( 0, 65536*green/XBGI->BGI.Palette.size, 65536-1 );
  xcolor.blue  = minmax( 0, 65536*blue /XBGI->BGI.Palette.size, 65536-1 );
  xcolor.flags = DoRed | DoGreen | DoBlue;
  XStoreColor( XBGI->Disp, XBGI->ColorMap, &xcolor );
  XFlush( XBGI->Disp );
}
void settextjustify( int horiz, int vert )
{
  XBGI->BGI.TextSetting.horiz = horiz;
  XBGI->BGI.TextSetting.vert  = vert;
}
void settextstyle( int font, int direction, int charsize )
{
  XBGI->BGI.TextSetting.font      = font;
  XBGI->BGI.TextSetting.direction = direction;
  XBGI->BGI.TextSetting.charsize  = charsize;
  XBGI->FontInfo = XLoadQueryFont( XBGI->Disp, XBGIFontName[font][charsize] );
  XSetFont( XBGI->Disp, XBGI->GC, XBGI->FontInfo->fid );
}
void setusercharsize( int multx, int divx, int multy, int divy )
{
  rferror( "setusercharsize()" );
}
void setviewport( int left, int top, int right, int bottom, int clip )
{
  XRectangle rec[1];

  XBGI->BGI.ViewPort.left   = min(left,right);
  XBGI->BGI.ViewPort.top    = min(top,bottom);
  XBGI->BGI.ViewPort.right  = max(left,right);
  XBGI->BGI.ViewPort.bottom = max(top,bottom);
  XBGI->BGI.ViewPort.clip   = clip;
  if ( XBGI->BGI.ViewPort.clip == FALSE ){
    XSetClipMask( XBGI->Disp, XBGI->GC,         None );
    XSetClipMask( XBGI->Disp, XBGI->GCPutPixel, None );
    XSetClipMask( XBGI->Disp, XBGI->GCPutImage, None );
    XSetClipMask( XBGI->Disp, XBGI->GCFill,     None );
  }else{
    rec[0].x = XBGI->BGI.ViewPort.left;
    rec[0].y = XBGI->BGI.ViewPort.top;
    rec[0].width  = XBGI->BGI.ViewPort.right - XBGI->BGI.ViewPort.left + 1;
    rec[0].height = XBGI->BGI.ViewPort.bottom - XBGI->BGI.ViewPort.top + 1;
    XSetClipRectangles( XBGI->Disp, XBGI->GC,         0, 0, rec, 1, Unsorted );
    XSetClipRectangles( XBGI->Disp, XBGI->GCPutPixel, 0, 0, rec, 1, Unsorted );
    XSetClipRectangles( XBGI->Disp, XBGI->GCPutImage, 0, 0, rec, 1, Unsorted );
    XSetClipRectangles( XBGI->Disp, XBGI->GCFill,     0, 0, rec, 1, Unsorted );
  }
}
void setvisualpage( int page )
{
  if (( 0<=page )&&( page<XBGIMaxPage )){
    XBGI->BGI.VisualPage = page;
    XMapRaised( XBGI->Disp, XBGI->Win[XBGI->BGI.VisualPage] );
  }else if( page == -1 ){
    XBGI->BGI.VisualPage = page;
    XMapRaised( XBGI->Disp, XBGI->Root );
  }
}
void setwritemode( int mode )
{
  XSetFunction( XBGI->Disp, XBGI->GC,         XBGIOpTable[mode] );
  XSetFunction( XBGI->Disp, XBGI->GCPutPixel, XBGIOpTable[mode] );
  XSetFunction( XBGI->Disp, XBGI->GCPutImage, XBGIOpTable[mode] );
  XSetFunction( XBGI->Disp, XBGI->GCFill,     XBGIOpTable[mode] );
}
int textheight( char *textstring )
{
  return( XBGI->FontInfo->max_bounds.ascent + XBGI->FontInfo->max_bounds.descent );
}
int textwidth( char *textstring )
{
  return( XTextWidth(XBGI->FontInfo, textstring, strlen(textstring)) );
}
static int scan_option( int argc, char *argv[], char *str, ... )
{
  int i, j;
  va_list argptr;
  char opt[64], buf[256], fmt[256], *p;
  
  va_start( argptr, str );
  strcpy( opt, str );
  if ( (p=strchr(opt,'%'))!=NULL ){
    strcpy( fmt, p );
    *p = '\0';
  }else{
    for ( i=0; i<argc; i++ )
      if ( strcmp( argv[i], str )==0 )
        return( i );
    return( 0 );
  }
  while ( *(--p)==' ' ) *p = '\0';
  /*printf( "opt = %s, fmt = %s \n", opt, fmt );*/
  
  for ( i=0; i<argc; i++ )
    if ( (strcmp(argv[i],opt)==0)&&(i+1<argc) ){
      j = i+1;
      strcpy( buf, argv[j] );
      while ( ++j<argc ){
        strcat( buf, " " );
        strcat( buf, argv[j] );
      }
      /*printf( "buf = %s \n", buf );*/
      vsscanf( buf, fmt, argptr );
      return( i );
    }
  return( 0 );
}
/*** graphics initializer for xbgi ***/
void initgraphxbgi( int *graphdriver, int *graphmode, char *pathtodriver )
{
  int i;
  int argc = 0; char **argv, *ptr, options[256], disp[64] = "";
  XEvent ev;
  XSetWindowAttributes att;
  XSizeHints def, usr;

  /* parameter settings */
  strcpy( options, pathtodriver );
  ptr = strtok( options, " " );
  while ( ptr != NULL ){
    argc++;
    ptr = strtok( NULL, " " );
  }
  argc++;
  argv = (char**)malloc( argc*sizeof(char*) );
  argv[0] = "XBGI";
  i = 1;
  strcpy( options, pathtodriver );
  ptr = strtok( options, " " );
  while ( ptr != NULL ){
    argv[i++] = ptr;
    ptr = strtok( NULL, " " );
  }

  /* initialization */
  scan_option( argc, argv, "-display %s", disp );
  XBGI->Disp   = XOpenDisplay( disp );
  XBGI->Screen = DefaultScreen( XBGI->Disp );

  /* default window position and size */
  def.x = 0; 
  def.y = 0;
  def.width  = 640; 
  def.height = 400;
  def.flags = PSize | USSize;

  /* user window position and size */
  usr.x = 0; 
  usr.y = 0;
  usr.width  = 640; 
  usr.height = 400;
  scan_option( argc, argv, "-geometry %dx%d%d%d",
	      &(usr.width), &(usr.height), &(usr.x), &(usr.y) );
  if ( def.x != usr.x ){
    def.x = usr.x;
    def.flags = PPosition;
  }
  if ( def.y != usr.y ){
    def.y = usr.y;
    def.flags = def.flags | USPosition;
  }
  if ( def.width != usr.width ){
    def.width = usr.width;
    def.flags = def.flags | PSize;
  }
  if ( def.height != usr.height ){
    def.height = usr.height;
    def.flags = def.flags | USSize;
  }

  /* create windows */
  XBGI->Root = XCreateSimpleWindow( XBGI->Disp, RootWindow(XBGI->Disp,XBGI->Screen),
				   def.x, def.y, def.width, def.height, 0,
				   WhitePixel(XBGI->Disp,XBGI->Screen),
				   BlackPixel(XBGI->Disp,XBGI->Screen) );
  XSetStandardProperties( XBGI->Disp, XBGI->Root, "XBGI", "XBGI", None, argv, argc, &def );

  /* input event selection, GC creation and so on */
  XBGI->Depth  = DefaultDepth( XBGI->Disp, XBGI->Screen );
  XSelectInput( XBGI->Disp, XBGI->Root,
	       ExposureMask|KeyPressMask|ButtonPressMask|StructureNotifyMask );
  XBGI->GC         = XCreateGC( XBGI->Disp, XBGI->Root, 0, NULL );
  XBGI->GCPutPixel = XCreateGC( XBGI->Disp, XBGI->Root, 0, NULL );
  XBGI->GCPutImage = XCreateGC( XBGI->Disp, XBGI->Root, 0, NULL );
  XBGI->GCFill     = XCreateGC( XBGI->Disp, XBGI->Root, 0, NULL );
  att.backing_store = Always;
  for ( i=0; i<XBGIMaxPage; i++ ){
    XBGI->Win[i] = XCreateSimpleWindow( XBGI->Disp, XBGI->Root, 0, 0, def.width, def.height, 0,
				       WhitePixel(XBGI->Disp,XBGI->Screen),
				       BlackPixel(XBGI->Disp,XBGI->Screen) );
    XSelectInput( XBGI->Disp, XBGI->Win[i],
		 ExposureMask|KeyPressMask|ButtonPressMask|StructureNotifyMask );
    XChangeWindowAttributes( XBGI->Disp, XBGI->Win[i], CWBackingStore, &att );
  }

  /* BGI default setting */
  setgraphmode( XBGI->BGI.Mode );
  switch( XBGI->BGI.Driver ){
  case DETECT:
  case BGIX:
    graphdefaults();
    setmaxx( def.width -1 );
    setmaxy( def.height-1 );
    setviewport( 0, 0, def.width-1, def.height-1, !0 );
    break;
  case BGIXHI:
    graphdefaults();
    setmaxx( 1119 );
    setmaxy(  749 );
    setviewport( 0, 0, 1119, 749, !0 );
    break;
  default:
    graphdefaults();
    break;
  }

  /* waiting for expose event */
  XMapWindow( XBGI->Disp, XBGI->Root );
  XMapSubwindows( XBGI->Disp, XBGI->Root ); 
  XMapRaised( XBGI->Disp, XBGI->Win[XBGI->BGI.VisualPage] );
  XFlush( XBGI->Disp );
  XBGI->BGI.Error = grOk;
  do{
    XNextEvent( XBGI->Disp, &ev );
  }while ( Expose != ev.type );
  XFlush( XBGI->Disp );
}
